package cn.com.tenlion.freemarker.service.templateconfig.impl;

import cn.com.tenlion.freemarker.dao.templateconfig.ITemplateConfigDao;
import cn.com.tenlion.freemarker.pojo.dtos.templateconfig.TemplateConfigDTO;
import cn.com.tenlion.freemarker.pojo.vos.templateconfig.TemplateConfigVO;
import cn.com.tenlion.freemarker.pojo.vos.templaterecord.TemplateRecordVO;
import cn.com.tenlion.freemarker.service.templateconfig.ITemplateConfigService;
import cn.com.tenlion.freemarker.service.templaterecord.ITemplateRecordService;
import cn.com.tenlion.freemarker.util.TemplateBuilderUtil;
import cn.com.tenlion.freemarker.util.TemplateCreateData;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.util.concurrent.AbstractService;
import ink.wgink.common.base.DefaultBaseService;
import ink.wgink.exceptions.RemoveException;
import ink.wgink.exceptions.SaveException;
import ink.wgink.exceptions.SearchException;
import ink.wgink.exceptions.UpdateException;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResult;
import ink.wgink.pojo.result.SuccessResultList;
import ink.wgink.util.UUIDUtil;
import ink.wgink.util.map.HashMapUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @ClassName: TemplateConfigServiceImpl
 * @Description: 新闻模板表
 * @Author: WenG
 * @Date: 2020-05-07 16:44
 * @Version: 1.0
 **/
@Primary
@Service
public class TemplateConfigServiceImpl extends DefaultBaseService implements ITemplateConfigService {

    @Autowired
    private ITemplateConfigDao templateConfigDao;
    @Autowired
    private ITemplateRecordService iTemplateConfigRecordService;

    @Override
    public SuccessResult saveTemplateConfig(TemplateConfigVO templateConfigVO) throws Exception {
        saveTemplateConfigInfo(null, templateConfigVO);
        return new SuccessResult();
    }

    @Override
    public SuccessResult saveTemplateConfigByToken(String token, TemplateConfigVO templateConfigVO) throws Exception {
        saveTemplateConfigInfo(token, templateConfigVO);
        return new SuccessResult();
    }

    /**
     * 新增新闻模板表
     *
     * @param token
     * @param templateConfigVO
     * @throws Exception
     */
    private void saveTemplateConfigInfo(String token, TemplateConfigVO templateConfigVO) throws Exception {
        Map<String, Object> params = HashMapUtil.beanToMap(templateConfigVO);
        String templateConfigId = UUIDUtil.getUUID();
        params.put("templateConfigId", templateConfigId);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        /**
         * 查询编码是否已经存在
         */
        TemplateConfigDTO DTO = templateConfigDao.getTemplateConfigByCode(params);
        if(DTO != null) {
            throw new SaveException("该编码已经存在");
        }
        String templateContent = "// CBC 其他模块批量生成示例代码, 遍历您的业务数据集循环调用下列代码, 如果需要实时生成, 请在您的新增修改的结尾调用下面代码 17691030315\n" +
                "// 将您的业务数据对象转为Map\n" +
                "Map<String, Object> templateDataMap = HashMapUtil.beanToMap(您的实体对象);\n" +
                "// 创建模板数据封装对象\n" +
                "TemplateCreateData createData = new TemplateCreateData();\n" +
                "// 您的业务关联的模板引擎编码\n" +
                "createData.setTemplateCode(\"C0001\");\n" +
                "// 您的业务表主键ID唯一识别, 请确保该值不会重复\n" +
                "createData.setBusinessId(您的业务主键);\n" +
                "// 您自定义的模板说明, 用于后期在模板生成记录中模糊查找使用\n" +
                "createData.setBusinessContent(您的自定义内容);\n" +
                "// 您的业务数据对象\n" +
                "createData.setTemplateDataMap(templateDataMap);\n" +
                "// 生成模板文件, 返回模板生成记录对象\n" +
                "TemplateRecordVO recordVo =  TemplateBuilderUtil.getInstance().createFile(createData);";
        params.put("templateContent", templateContent);
        templateConfigDao.saveTemplateConfig(params);
        /**
         * 更新保存操作 2020年5月8日16:02:39 崔宝铖
         */
        Map<String, Object> query = super.getHashMap(1);
        query.put("templateConfigId", templateConfigId);
        TemplateConfigDTO templateDTO = templateConfigDao.getTemplateConfig(query);
        TemplateBuilderUtil.getInstance().pushTemplate(templateDTO.getTemplateCode(), templateDTO);
    }

    @Override
    public SuccessResult removeTemplateConfig(String ids) throws RemoveException {
        removeTemplateConfigInfo(null, ids);
        return new SuccessResult();
    }

    @Override
    public SuccessResult removeTemplateConfigByToken(String token, String ids) throws RemoveException {
        removeTemplateConfigInfo(token, ids);
        return new SuccessResult();
    }

    /**
     * 删除新闻模板表
     *
     * @param token
     * @param ids
     */
    private void removeTemplateConfigInfo(String token, String ids) {
        Map<String, Object> params = getHashMap(3);
        List<String> list = Arrays.asList(ids.split("_"));
        /**
         * 更新删除操作 2020年5月8日16:02:39 崔宝铖
         */
        Map<String, Object> query = super.getHashMap(1);
        for (String templateConfigId:  list) {
            query.put("templateConfigId", templateConfigId);
            TemplateConfigDTO templateDTO = templateConfigDao.getTemplateConfig(query);
            TemplateBuilderUtil.getInstance().removeTemplate(templateDTO.getTemplateCode());
        }
        /**
         * 更新删除操作
         */
        params.put("templateConfigIds", list);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        templateConfigDao.removeTemplateConfig(params);
    }

    @Override
    public SuccessResult updateTemplateConfig(String templateConfigId, TemplateConfigVO templateConfigVO) throws Exception {
        updateTemplateConfigInfo(null, templateConfigId, templateConfigVO);
        return new SuccessResult();
    }

    @Override
    public SuccessResult updateTemplateConfigByToken(String token, String templateConfigId, TemplateConfigVO templateConfigVO) throws Exception {
        updateTemplateConfigInfo(token, templateConfigId, templateConfigVO);
        return new SuccessResult();
    }

    /**
     * 修改新闻模板表
     *
     * @param token
     * @param templateConfigId
     * @param templateConfigVO
     */
    private void updateTemplateConfigInfo(String token, String templateConfigId, TemplateConfigVO templateConfigVO) throws Exception {
        Map<String, Object> params = HashMapUtil.beanToMap(templateConfigVO);
        params.put("templateConfigId", templateConfigId);
        if (StringUtils.isBlank(token)) {
            setSaveInfo(params);
        } else {
            setAppSaveInfo(token, params);
        }
        /**
         * 更新修改操作
         */
        templateConfigDao.updateTemplateConfig(params);
        /**
         * 更新修改操作 2020年5月8日16:02:39 崔宝铖
         */
        Map<String, Object> query = super.getHashMap(1);
        query.put("templateConfigId", templateConfigId);
        TemplateConfigDTO templateDTO = templateConfigDao.getTemplateConfig(query);
        TemplateBuilderUtil.getInstance().pushTemplate(templateDTO.getTemplateCode(), templateDTO);
    }

    @Override
    public TemplateConfigDTO getTemplateConfigById(String templateConfigId) throws SearchException {
        Map<String, Object> params = super.getHashMap(1);
        params.put("templateConfigId", templateConfigId);
        return templateConfigDao.getTemplateConfig(params);
    }

    @Override
    public List<TemplateConfigDTO> listTemplateConfig(Map<String, Object> params) throws SearchException {
        return templateConfigDao.listTemplateConfig(params);
    }

    @Override
    public SuccessResultList<List<TemplateConfigDTO>> listPageTemplateConfig(ListPage page) throws SearchException {
        PageHelper.startPage(page.getPage(), page.getRows());
        List<TemplateConfigDTO> templateConfigDTOs = templateConfigDao.listTemplateConfig(page.getParams());
        PageInfo<TemplateConfigDTO> pageInfo = new PageInfo<>(templateConfigDTOs);
        return new SuccessResultList<>(templateConfigDTOs, pageInfo.getPageNum(), pageInfo.getTotal());
    }

    @Override
    public SuccessResult updateTemplateConfigContent(String templateConfigId, String templateContent) throws Exception {
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("templateConfigId", templateConfigId);
        params.put("templateContent", templateContent);
        if(StringUtils.isEmpty(templateContent)) {
            throw new UpdateException("模板内容不能为空!");
        }
        setUpdateInfo(params);
        templateConfigDao.updateTemplateConfigContent(params);
        /**
         * 更新修改操作 2020年5月8日16:02:39 崔宝铖
         */
        Map<String, Object> query = super.getHashMap(1);
        query.put("templateConfigId", templateConfigId);
        TemplateConfigDTO templateDTO = templateConfigDao.getTemplateConfig(query);
        TemplateBuilderUtil.getInstance().pushTemplate(templateDTO.getTemplateCode(), templateDTO);
        /**
         * 更新修改操作
         */
        return new SuccessResult();
    }

}
